/**
 * COCTMT230100UVPackagedMedicine2.java
 *
 * File generated from the medication2::COCTMT230100UVPackagedMedicine2 uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication2;

import java.util.List;

// End of user code
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAnyElement;
import javax.xml.bind.annotation.XmlAnyAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.datatype.XMLGregorianCalendar;
import javax.xml.bind.annotation.XmlMixed;
import javax.xml.bind.annotation.XmlValue;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.namespace.QName;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class COCTMT230100UVPackagedMedicine2.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "COCT_MT230100UV.PackagedMedicine", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"id",
	"code",
	"name",
	"formCode",
	"lotNumberText",
	"capacityQuantity",
	"capTypeCode",
	"asManufacturedProduct",
	"asSuperContent",
	"subContent",
	"classCode",
	"determinerCode",
	"nullFlavor"
})
@XmlRootElement(name = "COCT_MT230100UV.PackagedMedicine")
public class COCTMT230100UVPackagedMedicine2 implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.infr.AllInfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> templateId;
	@XmlElement(name = "id", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.II2 id;
	@XmlElement(name = "code", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.CE2 code;
	@XmlElement(name = "name", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication2.TN2> name;
	@XmlElement(name = "formCode", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.CE2 formCode;
	@XmlElement(name = "lotNumberText", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.ST12 lotNumberText;
	@XmlElement(name = "capacityQuantity", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.PQ2 capacityQuantity;
	@XmlElement(name = "capTypeCode", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.CE2 capTypeCode;
	@XmlElement(name = "asManufacturedProduct", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication2.COCTMT230100UVManufacturedProduct2> asManufacturedProduct;
	@XmlElement(name = "asSuperContent", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.COCTMT230100UVSuperContent2 asSuperContent;
	@XmlElement(name = "subContent", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.COCTMT230100UVSubContent2 subContent;
	@XmlAttribute(name = "classCode", required = true)
	public net.ihe.gazelle.medication2.EntityClassContainer2 classCode;
	@XmlAttribute(name = "determinerCode", required = true)
	public net.ihe.gazelle.medication2.EntityDeterminer2 determinerCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.medication2.NullFlavor2 nullFlavor;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.infr.AllInfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.infr.AllInfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.infr.AllInfrastructureRootTemplateId> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}
	
	/**
	 * Return id.
	 * @return id
	 */
	public net.ihe.gazelle.medication2.II2 getId() {
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(net.ihe.gazelle.medication2.II2 id) {
	    this.id = id;
	}
	
	
	
	
	/**
	 * Return code.
	 * @return code
	 */
	public net.ihe.gazelle.medication2.CE2 getCode() {
	    return code;
	}
	
	/**
	 * Set a value to attribute code.
	 * @param code.
	 */
	public void setCode(net.ihe.gazelle.medication2.CE2 code) {
	    this.code = code;
	}
	
	
	
	
	/**
	 * Return name.
	 * @return name
	 */
	public List<net.ihe.gazelle.medication2.TN2> getName() {
		if (name == null) {
	        name = new ArrayList<net.ihe.gazelle.medication2.TN2>();
	    }
	    return name;
	}
	
	/**
	 * Set a value to attribute name.
	 * @param name.
	 */
	public void setName(List<net.ihe.gazelle.medication2.TN2> name) {
	    this.name = name;
	}
	
	
	
	/**
	 * Add a name to the name collection.
	 * @param name_elt Element to add.
	 */
	public void addName(net.ihe.gazelle.medication2.TN2 name_elt) {
	    this.getName().add(name_elt);
	}
	
	/**
	 * Remove a name to the name collection.
	 * @param name_elt Element to remove
	 */
	public void removeName(net.ihe.gazelle.medication2.TN2 name_elt) {
	    this.getName().remove(name_elt);
	}
	
	/**
	 * Return formCode.
	 * @return formCode
	 */
	public net.ihe.gazelle.medication2.CE2 getFormCode() {
	    return formCode;
	}
	
	/**
	 * Set a value to attribute formCode.
	 * @param formCode.
	 */
	public void setFormCode(net.ihe.gazelle.medication2.CE2 formCode) {
	    this.formCode = formCode;
	}
	
	
	
	
	/**
	 * Return lotNumberText.
	 * @return lotNumberText
	 */
	public net.ihe.gazelle.medication2.ST12 getLotNumberText() {
	    return lotNumberText;
	}
	
	/**
	 * Set a value to attribute lotNumberText.
	 * @param lotNumberText.
	 */
	public void setLotNumberText(net.ihe.gazelle.medication2.ST12 lotNumberText) {
	    this.lotNumberText = lotNumberText;
	}
	
	
	
	
	/**
	 * Return capacityQuantity.
	 * @return capacityQuantity
	 */
	public net.ihe.gazelle.medication2.PQ2 getCapacityQuantity() {
	    return capacityQuantity;
	}
	
	/**
	 * Set a value to attribute capacityQuantity.
	 * @param capacityQuantity.
	 */
	public void setCapacityQuantity(net.ihe.gazelle.medication2.PQ2 capacityQuantity) {
	    this.capacityQuantity = capacityQuantity;
	}
	
	
	
	
	/**
	 * Return capTypeCode.
	 * @return capTypeCode
	 */
	public net.ihe.gazelle.medication2.CE2 getCapTypeCode() {
	    return capTypeCode;
	}
	
	/**
	 * Set a value to attribute capTypeCode.
	 * @param capTypeCode.
	 */
	public void setCapTypeCode(net.ihe.gazelle.medication2.CE2 capTypeCode) {
	    this.capTypeCode = capTypeCode;
	}
	
	
	
	
	/**
	 * Return asManufacturedProduct.
	 * @return asManufacturedProduct
	 */
	public List<net.ihe.gazelle.medication2.COCTMT230100UVManufacturedProduct2> getAsManufacturedProduct() {
		if (asManufacturedProduct == null) {
	        asManufacturedProduct = new ArrayList<net.ihe.gazelle.medication2.COCTMT230100UVManufacturedProduct2>();
	    }
	    return asManufacturedProduct;
	}
	
	/**
	 * Set a value to attribute asManufacturedProduct.
	 * @param asManufacturedProduct.
	 */
	public void setAsManufacturedProduct(List<net.ihe.gazelle.medication2.COCTMT230100UVManufacturedProduct2> asManufacturedProduct) {
	    this.asManufacturedProduct = asManufacturedProduct;
	}
	
	
	
	/**
	 * Add a asManufacturedProduct to the asManufacturedProduct collection.
	 * @param asManufacturedProduct_elt Element to add.
	 */
	public void addAsManufacturedProduct(net.ihe.gazelle.medication2.COCTMT230100UVManufacturedProduct2 asManufacturedProduct_elt) {
	    this.getAsManufacturedProduct().add(asManufacturedProduct_elt);
	}
	
	/**
	 * Remove a asManufacturedProduct to the asManufacturedProduct collection.
	 * @param asManufacturedProduct_elt Element to remove
	 */
	public void removeAsManufacturedProduct(net.ihe.gazelle.medication2.COCTMT230100UVManufacturedProduct2 asManufacturedProduct_elt) {
	    this.getAsManufacturedProduct().remove(asManufacturedProduct_elt);
	}
	
	/**
	 * Return asSuperContent.
	 * @return asSuperContent
	 */
	public net.ihe.gazelle.medication2.COCTMT230100UVSuperContent2 getAsSuperContent() {
	    return asSuperContent;
	}
	
	/**
	 * Set a value to attribute asSuperContent.
	 * @param asSuperContent.
	 */
	public void setAsSuperContent(net.ihe.gazelle.medication2.COCTMT230100UVSuperContent2 asSuperContent) {
	    this.asSuperContent = asSuperContent;
	}
	
	
	
	
	/**
	 * Return subContent.
	 * @return subContent
	 */
	public net.ihe.gazelle.medication2.COCTMT230100UVSubContent2 getSubContent() {
	    return subContent;
	}
	
	/**
	 * Set a value to attribute subContent.
	 * @param subContent.
	 */
	public void setSubContent(net.ihe.gazelle.medication2.COCTMT230100UVSubContent2 subContent) {
	    this.subContent = subContent;
	}
	
	
	
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.medication2.EntityClassContainer2 getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.medication2.EntityClassContainer2 classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return determinerCode.
	 * @return determinerCode
	 */
	public net.ihe.gazelle.medication2.EntityDeterminer2 getDeterminerCode() {
	    return determinerCode;
	}
	
	/**
	 * Set a value to attribute determinerCode.
	 * @param determinerCode.
	 */
	public void setDeterminerCode(net.ihe.gazelle.medication2.EntityDeterminer2 determinerCode) {
	    this.determinerCode = determinerCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.medication2.NullFlavor2 getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.medication2.NullFlavor2 nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication2");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "COCT_MT230100UV.PackagedMedicine").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(COCTMT230100UVPackagedMedicine2 cOCTMT230100UVPackagedMedicine2, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (cOCTMT230100UVPackagedMedicine2 != null){
   			cvm.validate(cOCTMT230100UVPackagedMedicine2, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: cOCTMT230100UVPackagedMedicine2.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.infr.AllInfrastructureRootTypeId.validateByModule(cOCTMT230100UVPackagedMedicine2.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.infr.AllInfrastructureRootTemplateId templateId: cOCTMT230100UVPackagedMedicine2.getTemplateId()){
					net.ihe.gazelle.infr.AllInfrastructureRootTemplateId.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication2.II2.validateByModule(cOCTMT230100UVPackagedMedicine2.getId(), _location + "/id", cvm, diagnostic);
			net.ihe.gazelle.medication2.CE2.validateByModule(cOCTMT230100UVPackagedMedicine2.getCode(), _location + "/code", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.TN2 name: cOCTMT230100UVPackagedMedicine2.getName()){
					net.ihe.gazelle.medication2.TN2.validateByModule(name, _location + "/name[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication2.CE2.validateByModule(cOCTMT230100UVPackagedMedicine2.getFormCode(), _location + "/formCode", cvm, diagnostic);
			net.ihe.gazelle.medication2.ST12.validateByModule(cOCTMT230100UVPackagedMedicine2.getLotNumberText(), _location + "/lotNumberText", cvm, diagnostic);
			net.ihe.gazelle.medication2.PQ2.validateByModule(cOCTMT230100UVPackagedMedicine2.getCapacityQuantity(), _location + "/capacityQuantity", cvm, diagnostic);
			net.ihe.gazelle.medication2.CE2.validateByModule(cOCTMT230100UVPackagedMedicine2.getCapTypeCode(), _location + "/capTypeCode", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication2.COCTMT230100UVManufacturedProduct2 asManufacturedProduct: cOCTMT230100UVPackagedMedicine2.getAsManufacturedProduct()){
					net.ihe.gazelle.medication2.COCTMT230100UVManufacturedProduct2.validateByModule(asManufacturedProduct, _location + "/asManufacturedProduct[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication2.COCTMT230100UVSuperContent2.validateByModule(cOCTMT230100UVPackagedMedicine2.getAsSuperContent(), _location + "/asSuperContent", cvm, diagnostic);
			net.ihe.gazelle.medication2.COCTMT230100UVSubContent2.validateByModule(cOCTMT230100UVPackagedMedicine2.getSubContent(), _location + "/subContent", cvm, diagnostic);
    	}
    }

}
